local Fern = CreateFrame("Frame", nil, UIParent)

local L = {}
if GetLocale() == "frFR" then
	L.Dodge = "Esquive"
	L.Parry = "Parade"
	L.Block = "Blocage"
	L.MCrit = "Critique cac"
	L.RCrit = "Critique distance"
	L.SCrit = "Critique sorts"
	L.MAP = "PA Cac"
	L.RAP = "PA distance"
	L.DSP = "Puissance sorts"
	L.HSP = "Puissance soins"
	L.SHa = "Hâte sorts"
	L.MHa = "Hâte Cac"
	L.RHa = "Hâte distance"
	L.MHi = "Toucher Cac"
	L.RHi = "Toucher distance"
	L.SHi = "Toucher sorts"
	L.Def = "Défense"
else 
	L.Dodge = "Dodge"
	L.Parry = "Parry"
	L.Block = "Block"
	L.MCrit = "Melee Crit"
	L.RCrit = "Ranged Crit"
	L.SCrit = "Spell Crit"
	L.MAP = "Melee AP"
	L.RAP = "Ranged AP"
	L.DSP = "Damage SP"
	L.HSP = "Healing SP"
	L.SHa = "Spell haste"
	L.MHa = "Melee haste"
	L.RHa = "Ranged haste"
	L.MHi = "Melee hit"
	L.RHi = "Ranged hit"
	L.SHi = "Spell hit"
	L.Def = "Defense"
end

local LDB = LibStub:GetLibrary("LibDataBroker-1.1")
Fern.Dodge = LDB:NewDataObject("Fern_"..L.Dodge, {
type = "data source",
label = L.Dodge,
text = "0%",
value = "0%"
})
Fern.Parry = LDB:NewDataObject("Fern_"..L.Parry, {
type = "data source",
label = L.Parry,
text = "0%",
value = "0%"
})
Fern.Block = LDB:NewDataObject("Fern_"..L.Block, {
type = "data source",
label = L.Block,
text = "0%",
value = "0%"
})
Fern.MCrit = LDB:NewDataObject("Fern_"..L.MCrit, {
type = "data source",
label = L.MCrit,
text = "0%",
value = "0%"
})
Fern.RCrit = LDB:NewDataObject("Fern_"..L.RCrit, {
type = "data source",
label = L.RCrit,
text = "0%",
value = "0%"
})
Fern.SCrit = LDB:NewDataObject("Fern_"..L.SCrit, {
type = "data source",
label = L.SCrit,
text = "0%",
value = "0%"
})
Fern.MAP = LDB:NewDataObject("Fern_"..L.MAP, {
type = "data source",
label = L.MAP,
text = "0",
value = "0"
})
Fern.RAP = LDB:NewDataObject("Fern_"..L.RAP, {
type = "data source",
label = L.RAP,
text = "0",
value = "0"
})
Fern.DSP = LDB:NewDataObject("Fern_"..L.DSP, {
type = "data source",
label = L.DSP,
text = "0%",
value = "0%"
})
Fern.HSP = LDB:NewDataObject("Fern_"..L.HSP, {
type = "data source",
label = L.HSP,
text = "0%",
value = "0%"
})
Fern.SHa = LDB:NewDataObject("Fern_"..L.SHa, {
type = "data source",
label = L.SHa,
text = "0%",
value = "0%"
})
Fern.MHa = LDB:NewDataObject("Fern_"..L.MHa, {
type = "data source",
label = L.MHa,
text = "0%",
value = "0%"
})
Fern.RHa = LDB:NewDataObject("Fern_"..L.RHa, {
type = "data source",
label = L.RHa,
text = "0%",
value = "0%"
})
Fern.MHi = LDB:NewDataObject("Fern_"..L.MHi, {
type = "data source",
label = L.MHi,
text = "0%",
value = "0%"
})
Fern.RHi = LDB:NewDataObject("Fern_"..L.RHi, {
type = "data source",
label = L.RHi,
text = "0%",
value = "0%"
})
Fern.SHi = LDB:NewDataObject("Fern_"..L.SHi, {
type = "data source",
label = L.SHi,
text = "0%",
value = "0%"
})
Fern.Defense = LDB:NewDataObject("Fern_"..L.Def, {
type = "data source",
label = L.Def,
text = "0",
value = "0"
})







Fern:SetScript("OnEvent", function(self, event, unit)
	if unit and unit ~= "player" then return end
	--Dodge
	local dodge = string.format("%.2f%%",GetDodgeChance())
	self.Dodge.value = dodge
	
	--Parry
	local parry = string.format("%.2f%%",GetParryChance())
	self.Parry.value = parry

	--Block
	local block = string.format("%.2f%%",GetBlockChance())
	self.Block.value = block

	--Melee Crit
	local mc = string.format("%.2f%%",GetCritChance())
	self.MCrit.value = mc
	
	--Ranged Crit
	local rc = string.format("%.2f%%",GetRangedCritChance())
	self.RCrit.value = rc
	
	--Spell Crit
	local sc = string.format("%.2f%%",GetSpellCritChance(1))
	self.SCrit.value = sc

	--Melee AP
	local base, posBuff, negBuff = UnitAttackPower("player")
	local effective = base + posBuff + negBuff
	local map = string.format("%d", effective)
	self.MAP.value = map
	
	--Ranged AP
	local rbase, rposBuff, rnegBuff = UnitRangedAttackPower("player")
	local reffective = rbase + rposBuff + rnegBuff
	local rap = string.format("%d", effective)
	self.RAP.value = rap

	--Damage Spell Power
	local dsp = string.format("%.2f%%",GetSpellBonusDamage(1))
	self.DSP.value = dsp

	--Healing Spell Power
	local hsp = string.format("%.2f%%",GetSpellBonusHealing())
	self.HSP.value = hsp

	--Spell Haste
	local sha = string.format("%.2f%%",GetCombatRatingBonus(20))
	self.SHa.value = sha

	--Melee Haste
	local mha = string.format("%.2f%%",GetCombatRatingBonus(18))
	self.MHa.value = mha
	
	--Ranged Haste
	local rha = string.format("%.2f%%",GetCombatRatingBonus(19))
	self.RHa.value = rha

	--Melee Haste
	local mhi = string.format("%.2f%%",GetCombatRatingBonus(6))
	self.MHi.value = mhi

	--Ranged Haste
	local rhi = string.format("%.2f%%",GetCombatRatingBonus(7))
	self.RHi.value = rhi

	--Spell Haste
	local shi = string.format("%.2f%%",GetCombatRatingBonus(8))
	self.SHi.value = shi

	--Defense
	local def = string.format("%.2f%%",GetCombatRating(2))
	self.Defense.value = def

end)
Fern:RegisterEvent("UNIT_MODEL_CHANGED")
Fern:RegisterEvent("PLAYER_LEVEL_UP")
Fern:RegisterEvent("UNIT_AURA")
Fern:RegisterEvent("PLAYER_LOGIN")
	

